#include <windows.h>
#include <genstub.c>

#include <atomtest.h>

// Atom name - constant string.
#define THE_ATOM               "A fun atom."

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch (uMsg)   // Process Windows messages.
   {
      case WM_CREATE: // Increase number of entries in top area of atom table to 73.
              InitAtomTable( 73 );
              return DefWindowProc( hWnd, uMsg, wParam, lParam );
      case WM_COMMAND:   // Process menu options.
              switch ( LOWORD( wParam ) )
                  {
                     case IDM_ADDATOM:       // Adds an atom.
                              AddAtom( THE_ATOM );
                              InvalidateRect( hWnd, NULL, TRUE );
                              UpdateWindow( hWnd );
                              break;
                     case IDM_DELETEATOM:    // Delete an atom.
                              if ( FindAtom( THE_ATOM ) )
                                 DeleteAtom( FindAtom(THE_ATOM) );
                              InvalidateRect( hWnd, NULL, TRUE );
                              UpdateWindow( hWnd );
                              break;
                     case IDM_EXIT:
                              DestroyWindow( hWnd );
                              break;
                  }
                  break;
      case WM_PAINT:
            {   // Show the results of searching for an atom.
                PAINTSTRUCT ps;
                char szWorkArea[33], szBuffer[128];
                ATOM aAnAtom = INVALID_ATOM;
                BeginPaint( hWnd, &ps );
                if (aAnAtom = FindAtom( THE_ATOM )) {
                   GetAtomName( aAnAtom, szWorkArea, 32 );
                   wsprintf( szBuffer, "Atom '%s' was found.", szWorkArea );
                }
                else
                   lstrcpy( szBuffer, "Atom must be added." );
                TextOut( ps.hdc, 0, 0, szBuffer, lstrlen( szBuffer ) );
                EndPaint( hWnd, &ps );
            }
            break ;
      case WM_DESTROY: // Atom table is destroyed on exit.
            PostQuitMessage( 0 );
      break ;
      default:
         return DefWindowProc( hWnd, uMsg, wParam, lParam );
   }
   return( 0L ) ;
}

#include <about.c>
